const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const mapper_stats = sequelize.define(
    'mapper_stats',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

total_plays: {
        type: DataTypes.INTEGER,
      
      

      },

ranked_loved_maps_count: {
        type: DataTypes.INTEGER,
      
      

      },

computed_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  mapper_stats.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




















//end loop



    db.mapper_stats.belongsTo(db.mappers, {
      as: 'mapper',
      foreignKey: {
        name: 'mapperId',
      },
      constraints: false,
    });




    db.mapper_stats.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.mapper_stats.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return mapper_stats;
};


